      program convertKB                                           
C
C     *********************************************************************** 
C     *                                                                     *  
C     * convertkb.f transforms the outputfile 'kbplot.dat' of the program  *  
C     * 'kbconv.f' into a form that can be used to create the corresponding *
C     * plots with 'gnuplot'                                                *
C     *                                                                     *
C     * written by Peter Schuster, April 1993                               *
C     *                                                                     *  
c mmga* interative ploting added by Manuel Maria Alemany, January 2000      *
C     *                                                                     *  
C     *********************************************************************** 
C
      parameter (nmax=5000,numw=20)
C      
      implicit double precision (a-h,o-z)
C
      dimension rx(nmax,numw), ry(nmax,numw),
     1 qx(nmax,numw), qy(nmax,numw),tx(nmax,numw), ty(nmax,numw), 
     2 numbr(numw), numbq(numw), numbt(numw)
C
      character* 3 howdat 
      character*12 labelr(numw),labelq(numw),labelt(numw)
C
      call input (nmax,numw,
     1 rx,ry,qx,qy,tx,ty,numbr,numbq,numbt,
     2 ir,iq,it,labelr,labelq,labelt)
C
C
      irsave=ir
      iqsave=iq
      itsave=it
C
      call outdat (nmax,numw,
     1 rx,ry,qx,qy,tx,ty,numbr,numbq,numbt,
     2 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
      ir=irsave
      iq=iqsave
      it=itsave
C
C     ask if plots or postscript-files are wanted
C
cccccc
c mmga
c
c   5  write(6,1000)
c1000  format(/,' Do you want <Gnuplot> to display the plots on the scree
c     1n',/,' or to create postscript- or pbm-files out of them?',//,' Ty
c     2pe <dis> for displaying or <ps> for creating postscript-files',/,
c     3' or <pbm> for creating pbm-files.')
c      read(5,1001)howdat
1001  format(a3)
C
C
c mmga
      HOWDAT='dis'
c mmga

      if(howdat.eq.'dis'.or.howdat.eq.'Dis'.or.howdat.eq.'DIS')then               
      call outdis(numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C      
      elseif(howdat.eq.'ps'.or.howdat.eq.' ps'.or.howdat.eq.'PS '.or.ho
     1wdat.eq.' PS')then               
      call outps(numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
      elseif(howdat.eq.'pbm'.or.howdat.eq.'Pbm'.or.howdat.eq.'PBM')then
      call outpbm(numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
c      else
c      write(6,1002)
c1002  format('You made a mistake. Please chose again.')
c      goto 5
      endif
C
C            
c 
c mmga
cccccc
      stop
      end
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   *** *   
C
      subroutine input (nmax,numw,
     1 rx,ry,qx,qy,tx,ty,numbr,numbq,numbt,
     2 ir,iq,it,labelr,labelq,labelt)
C
C     reads the input from <kbplot.dat>
C 
      parameter (mmax=5000)
C
      implicit double precision (a-h,o-z)
C
      dimension absc(mmax), ord(mmax), rx(nmax,numw), ry(nmax,numw),
     1 qx(nmax,numw), qy(nmax,numw),tx(nmax,numw), ty(nmax,numw), 
     2 numbr(numw), numbq(numw), numbt(numw)
C
      character*3 marker
      character*10 fname
      character*12 labelr(numw),labelq(numw),labelt(numw)
C
C
C
      ir=0
      iq=0
      it=0
C
C
C     asking for outputfile to be used
C            
      write(6,1001)
1001  format(/,' Which file shall be read from?',/,' Please give the nam 
     1e. (format = a10)',/,' Press <ENTER> to choose the default <kbplot
     2.dat>') 
      read(5,1002)fname
1002  format(a10)
      if(fname.eq.' ')fname='kbplot.dat'
C
C
C     opening file to read from
C     
      open(unit=3,file=fname,status='old',form='formatted')
C
C       
C     Read data columns
C 
   1  number=1
C   
C  5  read(3,1003,err=200,end=300)absc(number),ord(number)
C1003 format(1x,f7.4,3x,f10.6)
C
C     (it is not yet possible to read data formatted, because there
C      is not a unique format of the data in the file, unit3)
C
C       
   5  read(3,*,err=200,end=300)absc(number),ord(number)
         number=number+1          
         if(number.ge.nmax)then
            write(4,1004)
            write(6,1004)
1004  format(/,' NOT ALL NUMBERS READ! SET NEW DIMENSION FOR NMAX!',/)
            stop
         endif
      goto 5
C
C   
C     Backup one record and get marker
C
 200  backspace (unit=3)
      read(3,1005)marker
1005  format(8x,a3)
C
C
C
C     Potential markers 'p*r' for RQ = 'r'
C
      if(marker.eq.'psr')then
         ir=ir+1
         labelr(ir)='s - Kl & By '
         numbr(ir)=number-1
         call field1(nmax,numw,numbr,absc,ord,rx,ry,ir)
C
      elseif(marker.eq.'ppr')then
         ir=ir+1
         labelr(ir)='p - Kl & By '
         numbr(ir)=number-1
         call field1(nmax,numw,numbr,absc,ord,rx,ry,ir)
C
      elseif(marker.eq.'pdr')then
         ir=ir+1
         labelr(ir)='d - Kl & By '
         numbr(ir)=number-1
         call field1(nmax,numw,numbr,absc,ord,rx,ry,ir)
C
      elseif(marker.eq.'pfr')then
         ir=ir+1
         labelr(ir)='f - Kl & By '
         numbr(ir)=number-1
         call field1(nmax,numw,numbr,absc,ord,rx,ry,ir)
C
      elseif(marker.eq.'pgr')then
         ir=ir+1
         labelr(ir)='g - Kl & By '
         numbr(ir)=number-1
         call field1(nmax,numw,numbr,absc,ord,rx,ry,ir)
C
C         
C     Fourier markers 'p*q' for RQ = 'q'
C
      elseif(marker.eq.'psq')then
         iq=iq+1
         labelq(iq)='trans s K&B '
         numbq(iq)=number-1
         call field1(nmax,numw,numbq,absc,ord,qx,qy,iq)
C
      elseif(marker.eq.'ppq')then
         iq=iq+1
         labelq(iq)='trans p K&B '
         numbq(iq)=number-1
         call field1(nmax,numw,numbq,absc,ord,qx,qy,iq)
C
      elseif(marker.eq.'pdq')then
         iq=iq+1
         labelq(iq)='trans d K&B '
         numbq(iq)=number-1
         call field1(nmax,numw,numbq,absc,ord,qx,qy,iq)
C
      elseif(marker.eq.'pfq')then
         iq=iq+1
         labelq(iq)='trans f K&B '
         numbq(iq)=number-1
         call field1(nmax,numw,numbq,absc,ord,qx,qy,iq)
C
      elseif(marker.eq.'pgq')then
         iq=iq+1
         labelq(iq)='trans g K&B '
         numbq(iq)=number-1
         call field1(nmax,numw,numbq,absc,ord,qx,qy,iq)
C
C         
C     Area markers 'p*t' for RQ = 't'
C
      elseif(marker.eq.'pst')then
         it=it+1
         labelt(it)='pst'
         numbt(it)=number-1
         call field1(nmax,numw,numbt,absc,ord,tx,ty,it)
C
      elseif(marker.eq.'ppt')then
         it=it+1
         labelt(it)='ppt'
         numbt(it)=number-1
         call field1(nmax,numw,numbt,absc,ord,tx,ty,it)
C
      elseif(marker.eq.'pdt')then 
         it=it+1
         labelt(it)='pdt'
         numbt(it)=number-1
         call field1(nmax,numw,numbt,absc,ord,tx,ty,it)
C
      elseif(marker.eq.'pft')then
         it=it+1
         labelt(it)='pft'
         numbt(it)=number-1
         call field1(nmax,numw,numbt,absc,ord,tx,ty,it)
C
      elseif(marker.eq.'pgt')then
         it=it+1
         labelt(it)='pgt'
         numbt(it)=number-1
         call field1(nmax,numw,numbt,absc,ord,tx,ty,it)
C
C
      else 
         write(4,1007)
         write(6,1007)fname
1007     format(//,' ERROR WITHIN MARKERS - LOOK AT ',a10,' !',/)
         stop
      endif
      goto 1
 300  close (unit=3)
C
C     information for program-user
C
      write(6,9991)(numbr(i),i=1,ir)
9991  format(/,' numbers of rows in columns of p*r:   ',10i6)
      write(6,9992)(numbq(k),k=1,iq)
9992  format(' numbers of rows in columns of p*q:   ',10i6)
      write(6,9993)(numbt(j),j=1,it)
9993  format(' numbers of rows in columns of p*t:   ',10i6)    
C
      return
      end
C
C      
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
C
      subroutine field1(nmax,numw,num,x,y,fieldx,fieldy,ifield)
C
C
      implicit double precision (a-h,o-z)
C
      dimension num(numw),x(nmax),y(nmax),fieldx(nmax,numw),
     1 fieldy(nmax,numw)       
C
C
      do 10,i=1,num(ifield)
            fieldx(i,ifield)=x(i)
            fieldy(i,ifield)=y(i)
  10  continue 
      return
      end 
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
C
C ----------------- end of reading file kbplot.dat ---------------------
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
C
      subroutine outdat (nmax,numw,
     1 rx,ry,qx,qy,tx,ty,numbr,numbq,numbt,
     2 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
      parameter (nscale=20)
C
      implicit double precision (a-h,o-z)
C
      dimension  rx(nmax,numw), ry(nmax,numw),
     1 qx(nmax,numw), qy(nmax,numw),tx(nmax,numw), ty(nmax,numw), 
     3 numbr(numw), numbq(numw), numbt(numw),
     4 xmaxr(nscale), xmaxt(nscale)
C
      character*12 labelr(numw),labelq(numw),labelt(numw)
C
C
C     opening files to write to
C
C  1. 'kbop.gp'.....
C  2. 'kbtr.gp'.....
C  3. 'kbar.gp'.....
C       
cccccc
c mmga
c
      OPEN(UNIT=4,FILE='kbop.gp',STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN(UNIT=9,FILE='kbtr.gp',STATUS='UNKNOWN',FORM='FORMATTED')
      OPEN(UNIT=7,FILE='kbar.gp',STATUS='UNKNOWN',FORM='FORMATTED')

c      open(unit=4,file='kbop.gp',status='new',form='formatted')
c      open(unit=9,file='kbtr.gp',status='new',form='formatted')
c      open(unit=7,file='kbar.gp',status='new',form='formatted')
c
c mmga
cccccc
C
C 
C     write Kleinman & Bylander operators to         'kbop.gp'
C     output format:
C                                               x;psr;...;x;pgr 
C
      write(4,1108)(labelr(i),i=1,ir)
1108  format('#     r (a.u.)',2x,a12,19(14x,a12))
      write(4,1208)
1208  format('#')
      do 75,i=1,numbr(ir) 
         write(4,1008)(rx(i,kc),ry(i,kc),kc=1,ir)
1008     format(20(3x,f10.6))
  75  continue
C
C     scaling:
C
      do 76 kc=1,ir
         i=numbr(ir)
 760     if(abs(ry(i,kc)).lt.0.0001)then
            xmaxr(kc)=rx(i,kc)
            i=i-1
            goto 760
         else
            goto 76
      endif
  76  continue
      rxmax=xmaxr(1)
      if(ir.gt.1)then
         do 77 kc=2,ir
            if(xmaxr(kc).ge.xmaxr(kc-1))rxmax=xmaxr(kc)
  77     continue
      endif                                                                            
C
C
C     write Kleinman & Bylander Transforms to       'kbtr.gp'
C     output format:
C                                              x;psq;...x;pgq   
C
      write(9,1109)(labelq(i),i=1,iq)
1109  format('#   q (1/a.u.)',3x,a12,19(14x,a12))
      write(9,1209)
1209  format('#')       
C
      do 80,i=1,numbq(iq)
            write(9,1009)(qx(i,kc),qy(i,kc),kc=1,iq)
1009        format(20(3x,f10.6))
  80  continue
C
C  
C     write Kleinman & Bylander Areas to           'kbar.gp'
C     output format:
C                                             x;pst;...x;pgt
C
      write(7,1110)(labelt(i),i=1,it)
1110  format('#      r (a.u.)',8x,a12,19(16x,a12))  
      write(7,1210)
1210  format('#')       
C
         do 85,i=1,numbt(it)
            write(7,1010)(tx(i,kc),ty(i,kc),kc=1,it)
1010        format(11(4x,f10.6))
  85     continue
C
C   
C     scaling:
C
      do 86 kc=1,it
         i=numbt(it)
 860     if(abs(ty(i,kc)).lt.0.0001)then
            xmaxt(kc)=tx(i,kc)
            i=i-1
            goto 860
         else
            goto 86
      endif
  86  continue
C
      txmax=xmaxt(1)
      if(it.gt.1)then
         do 87 kc=2,it
            if(xmaxt(kc).ge.xmaxt(kc-1))txmax=xmaxt(kc)
  87     continue
      endif
C
cccccc
c mmga
c

      CLOSE(4)
      CLOSE(9)
      CLOSE(7)
c
c mmga
cccccc
      return
      end                        
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   *** 
C
      subroutine outdis(numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
C     writes the appropriate command-file to be accepted by gnuplot;
C     the file is called 'kbcommand.gp'
C     the plots will be shown on the screen by gnuplot.
C
      implicit double precision (a-h,o-z)
C
      character*12 labelr(numw), labelq(numw), labelt(numw) 
C
C
cccccc
c mmga
c
      CHARACTER*1 OPT,PAS
      CHARACTER*15 FNAME

      PAS='n'

c      open (unit=1,file='kbcommand.gp',status='new',form='formatted')
c
c mmga
cccccc
C
C    
C
C
C     create first sheet: 'Kleinman & Bylander Operators'
C
cccccc
c mmga
c
      CALL SPACE2
      WRITE(*,*)'****************************************************'
      WRITE(*,*)'*** IF YOU PROCEED OTHER GNUPLOTS WILL BE KILLED ***'
      WRITE(*,*)'****************************************************'

      CALL SPACE2
      WRITE(*,*)'KLEINMAN & BYLANDER OPERATORS'
      CALL SPACE1

      FNAME='command_kbop.gp'
      OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',FORM='FORMATTED')


C     scaling:
C
      icount=0
      do 9 i=1,20
         icount=icount+1
         rxmhlp=10.0-0.5*icount
         if(rxmax.lt.rxmhlp)rmaxx=rxmhlp
   9  continue      
C
c mmga

      X_MIN= 0.
      X_MAX= rmaxx
      Y_MIN=-10.
      Y_MAX= 5.

c mmga
 2002 write(1,98)
  98  format('set term x11')
 2004 write(1,99)
  99  format(41Hset title 'Kleinman & Bylander Operators',/,
     .'set nolabel',/,
     .'set key',/,
     .'set notime',/,
     .'set noparametric',/,
     .'set size',/,
     .20Hset format xy '%.1f',/,
     .'set nogrid',/,
     .21Hset xlabel 'r [a.u.]',/,
     .35Hset ylabel 'V(r) [(Ry/a^3)^0.5]' -2)
      WRITE(1,100)Y_MIN,Y_MAX,X_MIN,X_MAX
 100  format('set yrange [',f5.1,':',f5.1,']',/,
     .'set xrange [',f5.1,':',f5.1,']')
c      write(1,100)rmaxx
c 100  format('set nokey',/,'set notime',/,'set noparametric',/,'set size
c     1',/,'set autoscale y',/,'set xrange [0:',f4.1,']',/,20Hset format 
c     2xy '%.1f',/,'set nogrid',/,21Hset xlabel 'r [a.u.]',/,'set xtics',
c     3/,'set key',/,34Hset ylabel 'V(r) [(Ry/a^3)^0.5]' 7)
      write(1,104)
 104  format('plot ',1H\)
      do 5,i=1,ir
         write(1,105)2*i-1,2*i,labelr(i)
 105  format(9H'kbop.gp',' using ',i2,':',i2,5H ti ',a12,1H',
     .         ' w li,',1H\)
   5  continue
C
C
      write(1,111)   
 111  format(18H0 ti 'zero' w li 7)
c 111  format(15H0 ti ' ' w li 1)     
c      write(1,115)
c 115  format('pause -1',/,'#')

 115  FORMAT('pause 3600')

      DO WHILE(PAS.NE.'y')
      WRITE(1,115)
      CLOSE (1)
      CALL RUN_GNUPLOT(FNAME)
 2006 WRITE(*,*) 'Do you want to change the axis ranges? (y/n)'
      READ(*,2000) OPT
      IF(OPT.EQ.'y') THEN
 2001  WRITE(*,*) 'x-range (1), y-range (2) or both (3)'
       READ(*,2000) OPT
       IF(OPT.EQ.'1') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2002
       ELSEIF(OPT.EQ.'2') THEN
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2002
       ELSEIF(OPT.EQ.'3') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2002
       ELSE
        GOTO 2001
       ENDIF
      ELSEIF(OPT.EQ.'n') THEN
 2007  WRITE(*,*) 'Do you want to save the plot in a PS file? (y/n)'
       READ(*,2000) OPT
       IF(OPT.EQ.'y') THEN
        CALL SPACE1
        WRITE(*,*) '... SAVING IN FILE kbop.ps ...'
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        PAS='y'
        WRITE(1,2003)
 2003   FORMAT('set term postscript color '
     .         ,11H'Helvetica',/,
     .20Hset output 'kbop.ps')
        GOTO 2004
       ELSEIF(OPT.EQ.'n') THEN
        CALL KILL_GNUPLOT
        GOTO 2005
       ELSE
        GOTO 2007
       ENDIF
      ELSE
       GOTO 2006
      ENDIF
      ENDDO

      CLOSE(1)
      CALL RUN_GNUPLOT(FNAME)

 2005 CONTINUE

 2000 FORMAT(a1)

C
C
C     create second sheet: 'Kleinman & Bylander Transforms'
C

      CALL SPACE2
      WRITE(*,*)'KLEINMAN & BYLANDER TRANSFORM'
      CALL SPACE1

      FNAME='command_kbtr.gp'
      OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',FORM='FORMATTED')

      X_MIN=0.
      X_MAX=15.
      Y_MIN=-10.
      Y_MAX=5.
      PAS='n'

 2012 WRITE(1,98)
 2014 write(1,119)
 119  format(41Hset title 'Kleinman & Bylander Transform',/,
     .'set nolabel',/,
     .'set key',/,
     .'set notime',/,
     .'set noparametric',/,
     .'set size',/,
     .19Hset format y '%.2f',/,
     .23Hset xlabel 'q [1/a.u.]',/,
     .36Hset ylabel 'Bessel V(q) [Ry^0.5]' -2)
      WRITE(1,100)Y_MIN,Y_MAX,X_MIN,X_MAX
c      write(1,120)
c 120  format(19Hset format y '%.2f',/,'set xtics',/,'set key',/,
c     1'set autoscale y',/,'set autoscale x',/,
c     223Hset xlabel 'q [1/a.u.]',/,35Hset ylabel 'Bessel V(q) [Ry^0.5]' 
c     37)
c      write(1,121)
c 121  format('set nolabel')
      write(1,124)
 124  format('plot ',1H\)
      do 25,i=1,iq
         write(1,125)2*i-1,2*i,labelq(i)
 125  format(9H'kbtr.gp',' using ',i2,':',i2,5H ti ',a12,1H',
     .         ' w li,',1H\)
  25  continue
      write(1,111)
c      write(1,115)

      DO WHILE(PAS.NE.'y')
      WRITE(1,115)
      CLOSE (1)
      CALL RUN_GNUPLOT(FNAME)
 2016 WRITE(*,*) 'Do you want to change the axis ranges? (y/n)'
      READ(*,2000) OPT
      IF(OPT.EQ.'y') THEN
 2011  WRITE(*,*) 'x-range (1), y-range (2) or both (3)'
       READ(*,2000) OPT
       IF(OPT.EQ.'1') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2012
       ELSEIF(OPT.EQ.'2') THEN
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2012
       ELSEIF(OPT.EQ.'3') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2012
       ELSE
        GOTO 2011
       ENDIF
      ELSEIF(OPT.EQ.'n') THEN
 2017  WRITE(*,*) 'Do you want to save the plot in a PS file? (y/n)'
       READ(*,2000) OPT
       IF(OPT.EQ.'y') THEN
        CALL SPACE1
        WRITE(*,*) '... SAVING IN FILE kbtr.ps ...'
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        PAS='y'
        WRITE(1,2013)
 2013   FORMAT('set term postscript color '
     .         ,11H'Helvetica',/,
     .20Hset output 'kbtr.ps')
        GOTO 2014
       ELSEIF(OPT.EQ.'n') THEN
        CALL KILL_GNUPLOT
        GOTO 2015
       ELSE
        GOTO 2017
       ENDIF
      ELSE
       GOTO 2016
      ENDIF
      ENDDO

      CLOSE(1)
      CALL RUN_GNUPLOT(FNAME)

 2015 CONTINUE

C
C
C     create third sheet: 'Kleinman & Bylander Area'
C
C    scaling:
C
      icount=0
      do 37 i=1,20
         icount=icount+1
         txmhlp=10.0-0.5*icount
         if(txmax.lt.txmhlp)tmaxx=txmhlp
  37  continue      
C
      CALL SPACE2
      WRITE(*,*)'KLEINMAN & BYLANDER AREA'
      CALL SPACE1

      FNAME='command_kbar.gp'
      OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',FORM='FORMATTED')

      X_MIN=0.
      X_MAX=tmaxx
      Y_MIN=-1.
      Y_MAX=1.
      PAS='n'

 2022 WRITE(1,98)

 2024 write(1,139)
 139  format(36Hset title 'Kleinman & Bylander Area',/,
     .'set key ',/,     
     .'set nolabel',/,
     .'set notime',/,
     .'set noparametric',/,
     .'set size',/,
     .21Hset xlabel 'r [a.u.]',/,
     .25Hset ylabel 'V(r) [Ry]' -2,/,
     .20Hset format xy '%.1f')
      WRITE(1,100)Y_MIN,Y_MAX,X_MIN,X_MAX
c      write(1,140)tmaxx
c 140  format('set nolabel',/,'set key',/,'set autoscale y',
c     1/,'set xrange [0:',f4.1,']',/,21Hset xlabel 'r [a.u.]',/,
c     224Hset ylabel 'V(r) [Ry]' 5,/,20Hset format xy '%.1f',/,
c     3'set xtics')
      write(1,144)
 144  format('plot ',1H\)     
      do 45,i=1,it
         write(1,145)2*i-1,2*i,labelt(i)
 145     format(9H'kbar.gp',' using ',i2,':', i2,5H ti ',a5,
     1          1H',' w li,',1H\)
  45  continue
      write(1,111)
C
C
C
      DO WHILE(PAS.NE.'y')
      WRITE(1,115)
      CLOSE (1)
      CALL RUN_GNUPLOT(FNAME)
 2026 WRITE(*,*) 'Do you want to change the axis ranges? (y/n)'
      READ(*,2000) OPT
      IF(OPT.EQ.'y') THEN
 2021  WRITE(*,*) 'x-range (1), y-range (2) or both (3)'
       READ(*,2000) OPT
       IF(OPT.EQ.'1') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2022
       ELSEIF(OPT.EQ.'2') THEN
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2022
       ELSEIF(OPT.EQ.'3') THEN
        WRITE(*,*) 'Values of xmin xmax'
        READ(*,*) X_MIN,X_MAX
        WRITE(*,*) 'Values of ymin ymax'
        READ(*,*) Y_MIN,Y_MAX
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        GOTO 2022
       ELSE
        GOTO 2021
       ENDIF
      ELSEIF(OPT.EQ.'n') THEN
 2027  WRITE(*,*) 'Do you want to save the plot in a PS file? (y/n)'
       READ(*,2000) OPT
       IF(OPT.EQ.'y') THEN
        CALL SPACE1
        WRITE(*,*) '... SAVING IN FILE kbar.ps ...'
        CALL KILL_GNUPLOT
        OPEN (UNIT=1,FILE=FNAME,STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        PAS='y'
        WRITE(1,2023)
 2023   FORMAT('set term postscript color ',
     .          11H'Helvetica',/,
     .20Hset output 'kbar.ps')
        GOTO 2024
       ELSEIF(OPT.EQ.'n') THEN
        CALL KILL_GNUPLOT
        GOTO 2025
       ELSE
        GOTO 2027
       ENDIF
      ELSE
       GOTO 2026
      ENDIF
      ENDDO

      CLOSE(1)
      CALL RUN_GNUPLOT(FNAME)

 2025 CONTINUE

      CALL SYSTEM ('rm ./mmga_tempx ./mmga_tempt')
c
c mmga
cccccc
      return
      end
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
C
      subroutine outps (numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
C     writes the appropriate command-file to be accepted by gnuplot;
C     the file is called 'kbcommand.gp'
C     gnuplot will create postscript-files.
C
      implicit double precision (a-h,o-z)
C
      character*12 labelr(numw), labelq(numw), labelt(numw) 
C
C
      open (unit=1,file='kbcommand.gp',status='new',form='formatted')
C
C
C     create first sheet: 'Kleinman & Bylander Operators'
C
C     scaling:
C
      icount=0
      do 9 i=1,20
         icount=icount+1
         rxmhlp=10.0-0.5*icount
         if(rxmax.lt.rxmhlp)rmaxx=rxmhlp
   9  continue      
C
      write(1,97)
  97  format(20Hset output 'kbop.ps')    
      write(1,98)
  98  format(42Hset term postscript monochrome 'Helvetica')
      write(1,99)
  99  format('set nolabel',/,41Hset title 'Kleinman & Bylander Operators
     1')   
      write(1,100)rmaxx
 100  format('set nokey',/,'set notime',/,'set noparametric',/,'set size
     1',/,'set autoscale y',/,'set xrange [0:',f4.1,']',/,20Hset format 
     2xy '%.1f',/,'set nogrid',/,21Hset xlabel 'r [a.u.]',/,'set xtics',
     3/,'set key',/,34Hset ylabel 'V(r) [(Ry/a^3)^0.5]' 1)
      write(1,104)
 104  format('plot \\')
      do 5,i=1,ir
         write(1,105)2*i-1,2*i,labelr(i)
 105  format(9H'kbop.gp',' using ',i2,':',i2,5H ti ',a12,1H',' w li,\\')
   5  continue
C
      write(1,111)   
 111  format(15H0 ti ' ' w li 1)     
      write(1,115)
 115  format('#')
C
C
C     create second sheet: 'Kleinman & Bylander Transforms'
C
      write(1,117)
 117  format(20Hset output 'kbtr.ps')    
      write(1,119)
 119  format('set nolabel',/,42Hset title 'Kleinman & Bylander Transform
     1s')  
      write(1,120)
 120  format(19Hset format y '%.2f',/,'set xtics',/,'set key',/,
     1'set autoscale y',/,'set autoscale x',/,
     223Hset xlabel 'q [1/a.u.]',/,35Hset ylabel 'Bessel V(q) [Ry^0.5]' 
     31)
      write(1,121)
 121  format('set nolabel')
      write(1,124)
 124  format('plot \\')
      do 25,i=1,iq
         write(1,125)2*i-1,2*i,labelq(i)
 125  format(9H'kbtr.gp',' using ',i2,':',i2,5H ti ',a12,1H',' w li,\\')
  25  continue
      write(1,111)
      write(1,115)
C
C
C     create third sheet: 'Kleinman & Bylander Area'
C
C     scaling:
C
      icount=0
      do 37 i=1,20
         icount=icount+1
         txmhlp=10.0-0.5*icount
         if(txmax.lt.txmhlp)tmaxx=txmhlp
  37  continue      
C
      write(1,137)
 137  format(20Hset output 'kbar.ps')    
      write(1,139)
 139  format(36Hset title 'Kleinman & Bylander Area')     
      write(1,140)tmaxx
 140  format('set nolabel',/,'set key',/,'set autoscale y',
     1/,'set xrange [0:',f4.1,']',/,21Hset xlabel 'r [a.u.]',/,
     224Hset ylabel 'V(r) [Ry]' 5,/,20Hset format xy '%.1f',/,
     3'set xtics')
      write(1,144)
 144  format('plot \\')     
      do 45,i=1,it
         write(1,145)2*i-1,2*i,labelt(i)
 145     format(9H'kbar.gp',' using ',i2,':',i2,5H ti ',a5,
     1          1H',' w li,\\')
  45  continue
      write(1,111)
C
C
C
      return
      end
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
C
      subroutine outpbm(numw,
     1 ir,iq,it,labelr,labelq,labelt,rxmax,txmax)
C
C     writes the appropriate command-file to be accepted by gnuplot;
C     the file is called 'kbcommand.gp'
C     gnuplot will create portable bitmap-files.
C
      implicit double precision (a-h,o-z)
C
      character*12 labelr(numw), labelq(numw), labelt(numw) 
C
C
      open (unit=1,file='kbcommand.gp',status='new',form='formatted')
C
C
C     create first sheet: 'Kleinman & Bylander Operators'
C
C     scaling:
C
      icount=0
      do 9 i=1,20
         icount=icount+1
         rxmhlp=10.0-0.5*icount
         if(rxmax.lt.rxmhlp)rmaxx=rxmhlp
   9  continue      
C
      write(1,97)
  97  format(21Hset output 'kbop.pbm')    
      write(1,98)
  98  format('set term pbm')
      write(1,99)
      write(1,99)
  99  format('set nolabel',/,41Hset title 'Kleinman & Bylander Operators
     1')   
      write(1,100)rmaxx
 100  format('set nokey',/,'set notime',/,'set noparametric',/,'set size
     1',/,'set autoscale y',/,'set xrange [0:',f4.1,']',/,20Hset format 
     2xy '%.1f',/,'set nogrid',/,21Hset xlabel 'r [a.u.]',/,'set xtics',
     3/,'set key',/,34Hset ylabel 'V(r) [(Ry/a^3)^0.5]' 1)
      write(1,104)
 104  format('plot \\')
      do 5,i=1,ir
         write(1,105)2*i-1,2*i,labelr(i)
 105  format(9H'kbop.gp',' using ',i2,':',i2,5H ti ',a12,1H',' w li,\\')
   5  continue
C
      write(1,111)   
 111  format(15H0 ti ' ' w li 1)     
      write(1,115)
 115  format('#')
C
C
C     create second sheet: 'Kleinman & Bylander Transforms'
C
      write(1,117)
 117  format(21Hset output 'kbtr.pbm')    
      write(1,119)
 119  format('set nolabel',/,42Hset title 'Kleinman & Bylander Transform
     1s')  
      write(1,120)
 120  format(19Hset format y '%.2f',/,'set xtics',/,'set key',/,
     1'set autoscale y',/,'set autoscale x',/,
     223Hset xlabel 'q [1/a.u.]',/,35Hset ylabel 'Bessel V(q) [Ry^0.5]' 
     31)
      write(1,121)
 121  format('set nolabel')
      write(1,124)
 124  format('plot \\')
      do 25,i=1,iq
         write(1,125)2*i-1,2*i,labelq(i)
 125  format(9H'kbtr.gp',' using ',i2,':',i2,5H ti ',a12,1H',' w li,\\')
  25  continue
      write(1,111)
      write(1,115)
C
C
C     create third sheet: 'Kleinman & Bylander Area'
C
C     scaling:
C
      icount=0
      do 37 i=1,20
         icount=icount+1
         txmhlp=10.0-0.5*icount
         if(txmax.lt.txmhlp)tmaxx=txmhlp
  37  continue      
C
      write(1,137)
 137  format(21Hset output 'kbar.pbm')    
      write(1,139)
 139  format(36Hset title 'Kleinman & Bylander Area')     
      write(1,140)tmaxx
 140  format('set nolabel',/,'set key',/,'set autoscale y',
     1/,'set xrange [0:',f4.1,']',/,21Hset xlabel 'r [a.u.]',/,
     224Hset ylabel 'V(r) [Ry]' 5,/,20Hset format xy '%.1f',/,
     3'set xtics')
      write(1,144)
 144  format('plot \\')     
      do 45,i=1,it
         write(1,145)2*i-1,2*i,labelt(i)
 145     format(9H'kbar.gp',' using ',i2,':',i2,5H ti ',a5,
     1          1H',' w li,\\')
  45  continue
      write(1,111)
C
C
C
      return
      end
C
C***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***   ***
cccccc
c mmga
c
        SUBROUTINE RUN_GNUPLOT(FNAME)

        CHARACTER*15 FNAME
        CHARACTER*52 TMP

        OPEN(UNIT=3,FILE='mmga_tempx',STATUS='UNKNOWN',
     .       FORM='FORMATTED')
        WRITE(3,9003) FNAME
        CLOSE(3)

        CALL SYSTEM ('chmod +x ./mmga_tempx')
        CALL SYSTEM ('./mmga_tempx')

        TMP = 'ps | grep gnuplot > mmga_tempt | 1> /dev/null 2>&1 &'

        OPEN(UNIT=3,FILE='mmga_tempx',STATUS='UNKNOWN',
     .       FORM='FORMATTED')
        WRITE(3,*) TMP
        CLOSE(3)

        CALL SYSTEM ('chmod +x ./mmga_tempx')
        CALL SYSTEM ('./mmga_tempx')

 9003   FORMAT('gnuplot -bg white ',a16,' 1> /dev/null 2>&1 &')

        RETURN
        END
c
c mmga
c
	SUBROUTINE KILL_GNUPLOT

        INTEGER I,J
	CHARACTER*6  C_PID(50)
        
        I = 0

        OPEN(UNIT=3,FILE='mmga_tempt',STATUS='UNKNOWN',
     .       FORM='FORMATTED')
 2041   READ(3,9002,END=2042) C_PID(I+1)
        I = I + 1
        GOTO 2041
 2042   CONTINUE
        CLOSE(3)

        OPEN(UNIT=3,FILE='mmga_tempx',STATUS='UNKNOWN',
     .        FORM='FORMATTED')
        DO J = 1,I
          WRITE(3,9001) C_PID(J)
        ENDDO
        CLOSE(3)

        CALL SYSTEM ('chmod +x ./mmga_tempx')
        CALL SYSTEM ('./mmga_tempx')


 9002   FORMAT(a6)
 9001   FORMAT('kill -9 ',a6,' 1> /dev/null 2>&1  ')

	RETURN
	END	
c
c mmga
c
        SUBROUTINE SPACE1

        WRITE(*,*)

        RETURN
        END
c
c mmga
c
        SUBROUTINE SPACE2

        WRITE(*,*)
        WRITE(*,*)

        RETURN
        END
c
c mmga
cccccc
