      subroutine splint (nspline,xspline,yspline,ysplin2,
     *                   nfit,xfit,yfit)

C                   calculate spline interpolation
C  ON INPUT:
C  nspline: number of grid points of input mesh
C  xspline(nspline): input mesh
C  yspline(nspline): function on input mesh
C  ysplin2(nspline): second derivative of yspline on input mesh
C  nfit: number of points of output mesh
C  xfit(nfit): output mesh
C  ON OUTPUT:
C  yfit(nfit): function on output mesh

      implicit none
      integer klo,i,nfit,nspline,k,khi
      double precision xspline(nspline), yspline(nspline), 
     *       ysplin2(nspline),xfit(nfit), yfit(nfit),h,a,b
      klo = 1
      do i=1, nfit
        do k=klo+1, nspline
            if(xspline(k).ge.xfit(i)) then
               if(xspline(k-1).le.xfit(i)) then
                  khi = k
                  klo = k-1
               else
                  if (k-1.eq.1 .and. i.eq.1) then
                     stop '  SPLINT: xfit(1) < xspline(1)'
                  else
                     stop '  SPLINT: xfit not properly ordered'
                  end if
               end if
               h= xspline(khi) - xspline(klo)
               a= (xspline(khi)-xfit(i))/h
               b= (xfit(i)-xspline(klo))/h

               yfit(i) = a*yspline(klo) + b*yspline(khi)
     *              +( (a**3-a)*ysplin2(klo) +
     *              (b**3-b)*ysplin2(khi) ) *h*h/6
               go to 10
            end if
         end do
*        stop '  SPLINT: out of bounds'
* This is for the unlikely event that rmax exceed r(mesh)
        yfit(i)=0.0
 10     continue
      end do

      return
      end


